(******************************************************************************
*                                  dbEngMem                                   *
* memory database (collection based) interface to virtual databases           *
******************************************************************************)
unit dbEngMem;

interface

uses
   dbEngBas
   ,objects
   ,dateUnit
   ;

type
   databaseEngineMemoryPtr = ^ databaseEngineMemory;
   databaseEngineMemory = object(databaseEngine)

      constructor init;

      procedure gregorianToDate(m, d, y : integer; var dt); virtual;
      procedure dateToGregorian(const dt; var m, d, y : integer); virtual;

   end; { databaseEngineMemory object definition }

implementation



(******************************************************************************
*                          databaseEngineMemory.init                          *
******************************************************************************)
constructor databaseEngineMemory.init;
begin
   inherited init;
end; {databaseEngineMemory.init}

(******************************************************************************
*                    databaseEngineMemory.gregorianToDate                     *
******************************************************************************)
procedure databaseEngineMemory.gregorianToDate;
begin
   longint(dt) := gregToJul(m, d, y);
end; {databaseEngineMemory.gregorianToDate}

(******************************************************************************
*                    databaseEngineMemory.dateToGregorian                     *
******************************************************************************)
procedure databaseEngineMemory.dateToGregorian;
var
   ml, dl, yl : longint;
begin
   julToGreg(longint(dt), ml, dl, yl);
   m := ml;
   y := yl;
   d := dl;
end; {databaseEngineMemory.dateToGregorian}

end.
