unit Covarmn;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Grids, Matrix, math1,
  math2;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    RBScatter: TRadioButton;
    RBCovar: TRadioButton;
    RBCorrel: TRadioButton;
    SGInMat: TStringGrid;
    SGOutMat: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    ButClear: TButton;
    ButFill: TButton;
    Panel1: TPanel;
    SButExit: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure RBCovarClick(Sender: TObject);
    procedure RBScatterClick(Sender: TObject);
    procedure RBCorrelClick(Sender: TObject);
    procedure SGInMatKeyPress(Sender: TObject; var Key: Char);
    procedure ButClearClick(Sender: TObject);
    procedure ButFillClick(Sender: TObject);
    procedure SButExitClick(Sender: TObject);
  private
    procedure LoadStringGrids;
    procedure CalcOutMatrix;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  InMat    : TMatrix;
  OutMat   : TMatrix;


(***********************************************************)
procedure TForm1.LoadStringGrids;
(***********************************************************)

var
  i,j  : integer;

begin
for i:=1 to SGInMat.ColCount do
  SGInMat.Cells [i,0] := 'C'+strf(i,1,0);
for i:=1 to SGInMat.RowCount do
  SGInMat.Cells [0,i] := 'R'+strf(i,1,0);
for i:=1 to SGInMat.ColCount do
  for j:=1 to SGInMat.RowCount do
    SGInMat.Cells [i,j] := strf(InMat.Elem[i,j],1,3);
for i:=1 to SGOutMat.ColCount do
  SGOutMat.Cells [i,0] := 'C'+strf(i,1,0);
for i:=1 to SGOutMat.RowCount do
  SGOutMat.Cells [0,i] := 'R'+strf(i,1,0);
for i:=1 to SGOutMat.ColCount do
  for j:=1 to SGOutMat.RowCount do
    SGOutMat.Cells [i,j] := strf(OutMat.Elem[i,j],1,3);
end;


(***********************************************************)
procedure TForm1.CalcOutMatrix;
(***********************************************************)


begin
if RBScatter.Checked then
  CalcCovar (InMat, OutMat, 1, InMat.NrOfColumns, 1, InMat.NrOfRows, 0);
if RBCovar.Checked then
  CalcCovar (InMat, OutMat, 1, InMat.NrOfColumns, 1, InMat.NrOfRows, 1);
if RBCorrel.Checked then
  CalcCovar (InMat, OutMat, 1, InMat.NrOfColumns, 1, InMat.NrOfRows, 2);
end;

(***********************************************************)
procedure TForm1.FormActivate(Sender: TObject);
(***********************************************************)

var
  i,j  : integer;


begin
OutMat := TMatrix.Create (SGOutMat.ColCount-1,SGOutMat.RowCount-1);
InMat := TMatrix.Create (SGInMat.ColCount-1,SGInMat.RowCount-1);
for i:=1 to SGInMat.ColCount do
  for j:=1 to SGInMat.RowCount do
    InMat.Elem[i,j] := random;
CalcOutMatrix;
LoadStringGrids;
end;

(***********************************************************)
procedure TForm1.RBCovarClick(Sender: TObject);
(***********************************************************)

begin
CalcOutMatrix;
LoadStringGrids;
end;

(***********************************************************)
procedure TForm1.RBScatterClick(Sender: TObject);
(***********************************************************)

begin
CalcOutMatrix;
LoadStringGrids;
end;

(***********************************************************)
procedure TForm1.RBCorrelClick(Sender: TObject);
(***********************************************************)

begin
CalcOutMatrix;
LoadStringGrids;
end;

(***********************************************************)
procedure TForm1.SGInMatKeyPress(Sender: TObject; var Key: Char);
(***********************************************************)

var
  ix, iy : integer;
  v      : double;
  status : integer;

begin
if key = #13 then
  begin
  ix := SGInMat.Selection.Left;
  iy := SGInMat.Selection.Top;
  val (SGInMat.Cells[ix,iy],v,status);
  if status = 0 then
    InMat.ELem[ix,iy] := v;
  CalcOutMatrix;
  LoadStringGrids;
  end;
end;

(***********************************************************)
procedure TForm1.ButClearClick(Sender: TObject);
(***********************************************************)

begin
InMat.Fill (0);
CalcOutMatrix;
LoadStringGrids;
end;

(***********************************************************)
procedure TForm1.ButFillClick(Sender: TObject);
(***********************************************************)

var
  i,j : integer;

begin
for i:=1 to SGInMat.ColCount do
  for j:=1 to SGInMat.RowCount do
    InMat.Elem[i,j] := random;
CalcOutMatrix;
LoadStringGrids;
end;

(***********************************************************)
procedure TForm1.SButExitClick(Sender: TObject);
(***********************************************************)

begin
OutMat.Free;
InMat.Free;
close;
end;

end.
